#!/usr/bin/perl -T
#$Id: fastlog_type_rig.pl,v 1.1 2022/03/14 12:44:25 sqko Exp $
use strict;
use warnings;
use RFC::Rig;
$| = 1;
my $r = RFC::Rig->new(shift);
$r->check_run;
my $type = 'simplechannel';
my @names = ();
my $debug = 0;
my $interval = 1;
my $duration = 120;
foreach my $i (@ARGV)
{
    if ($i =~ /--/)
    {
	
	if ($i =~ /type\=(\w+)/)
	{
	    $type = $1;
	}
	if ($i =~ /duration\=(\w+)/)
	{
	    $duration = $1;
	}
	if ($i =~ /debug/)
	{
	    $debug = 1;
	}
	if ($i =~ /interval\=(\d+)/)
	{
	    $interval = $1;
	}
    }
    else
    {
	push @names,$i;
    }
}
$interval = 1 unless ($interval && $interval > 1);
my @devs = ();
foreach my $n (@names)
{
    my $d = $r->get_device($type,$n);
    if ($d)
    {
	push @devs,$d;
    }
    else
    {
	warn "Device $n of type $type was not found for $r!\n";
    }
}
my $dat = `date +"%Y:%m:%d:%H:%M:%S"`;
$dat =~ /([\d\:]*)/;
$dat = $1;
my $test = $r->session;
my $homedir = $RFC::Header::publicdir . 'rig' . $r->name . "/" . $r->name . 'test' . $test;
my $raadata = $homedir.'/fastlog.'.$dat.'.txt';
my $f = SemaforeFile->new($raadata);

my $st = time;
$st += $duration * 60;
while (time < $st)
{
    my $t = time;
    my $lt = localtime();
    my @l = ($t,$lt);
    for my $d (@devs)
    {
	push @l,$d,$d->read();
    }
    my $str = join("\t",@l);
    $f->append($str);
    sleep($interval);
}
